package com.ibm.edp.cic.core.ant;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IProgressMonitor;

import com.ibm.cic.common.core.model.IFix;
import com.ibm.cic.common.core.model.IOffering;
import com.ibm.cic.common.core.repository.IRepository;

public class CicChangeFixBase extends AbstractCicTransformFixMetadata 
{	
	protected List transform(IFix fix, IRepository repo, IProgressMonitor monitor) throws Exception
	{
		List rc = new ArrayList();
		
		IOffering baseOffering = getUnspecifiedUtils().findOffering(fix.getOfferingId(), versionUnspecified, toleranceUnspecified, monitor);
		
		// Currently we get the latest one from all source repositories
        List list = null;
        if(baseOffering == null)
        {
        	list = getRepositoryGroup().getAllOfferings(monitor);        	
        }
        else
        {
        	list = new ArrayList();
        	list.add( baseOffering );        	
        }
				
        for (Iterator iter = list.iterator(); iter.hasNext();) {
			
        	IOffering offer = (IOffering) iter.next();
			if( iter.hasNext() ) continue; 
			
			fix.setOffering( offer );
			fix.setOfferingVersion( offer.getVersion() );
			rc.add(  "SET baseOffering to " + offer.getIdentity() + ", " + offer.getVersion() + "" );
					   
					   
		    repo.deleteContent( fix );
			repo.refresh();
			repo.addContent( fix );
		}
		
		return rc;
	}	
}
