package com.ibm.edp.cic.core.ant;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IProgressMonitor;

import com.ibm.cic.common.core.model.IAssembly;
import com.ibm.cic.common.core.model.IFix;
import com.ibm.cic.common.core.model.IIncludedShareableEntity;
import com.ibm.cic.common.core.model.internal.CICWriter;
import com.ibm.cic.common.core.repository.IRepository;

import org.osgi.framework.Version;

public class CicReduceFixToTemplate extends AbstractCicTransformFixMetadata 
{	
	protected List transform(IFix fix, IRepository repo, IProgressMonitor monitor) throws Exception
	{
		List rc = new ArrayList();
		
		IAssembly assembly = fix.getAssembly();
		if(assembly == null) throw new Exception( "Cannot locate assembly for [" + fix.getIdentity().getId() + "]" );
		
		assertAssembly(assembly, rc,  monitor);				
		
		fix.setVersion( new Version("7.0.0.qualifier") );
		//fix.setOfferingVersion( versionUnspecified );
		assembly.setVersion( new Version("7.0.0.qualifier") );
		
		repo.deleteContent( fix );
		repo.refresh();
		
		File repositoryFile = fix.getRepository().getLocation().toFile();
		File fixesFile = new File( repositoryFile, fix.getLocation().toFile().getParent() );
		File templateFile = new File( fixesFile, fix.getIdentity().getId() + ".fix");
		writeFixTemplate(fix, templateFile, true);
		
		return rc;
	}
	
	private void writeFixTemplate(IFix fixTemplate, File file, boolean relaxedValidation) throws IOException 
	{
         CICWriter w = new CICWriter();
         if (relaxedValidation) {
             w.setMode(CICWriter.MF_RELAXED_VALIDATION);
         }
         w.writeFix(fixTemplate, file);
    }
	
	
    protected void assertAssembly(IAssembly assembly, List list, IProgressMonitor monitor)
    {
		for (Iterator iter = assembly.getChildren().iterator(); iter.hasNext();) {
			Object content = iter.next();
			if(content instanceof IIncludedShareableEntity)
			{
				IIncludedShareableEntity ise = (IIncludedShareableEntity)content;
				
			    reduceIncludedSE( ise, true );
			}
			else
			{
				list.add( "TBD: " + content.getClass().getName());	
			}			
		}
    	
    }
}
